﻿using System.Net.Sockets;
using System.Runtime.InteropServices;

// Create the TcpClient
TcpClient client = new TcpClient();

// Get the size of the uint to use to back the byte array
int size = Marshal.SizeOf((uint)0);

// Create the byte array
byte[] keepAlive = new byte[size * 3];

Buffer.BlockCopy(BitConverter.GetBytes((uint)1), 0, keepAlive, 0, size);
Buffer.BlockCopy(BitConverter.GetBytes((uint)1000), 0, keepAlive, size, size);
Buffer.BlockCopy(BitConverter.GetBytes((uint)500), 0, keepAlive, size * 2, size);

client.Client.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.KeepAlive, true);

client.Connect("192.168.0.199", 1024);

NetworkStream stream = client.GetStream();

stream.Write(new byte[] { 0x21 }, 0, 1); // 해당 명령어를 한번 보내면 계속해서 값을 던져줍니다.

byte[] buffer = new byte[128];
int i = 0;
client.ReceiveTimeout = 3000;

client.Client.Receive(buffer);

client.Client.BeginReceive(buffer, 0, 5,
                    SocketFlags.None, new AsyncCallback(OnDataReceived), buffer);
bool connected = true;

while (connected)
{
    Thread.Sleep(100);
   
}



void OnDataReceived(IAsyncResult async)
{
    try
    {
        byte[] theSockId = (byte[])async.AsyncState;
        int iRx = client.Client.EndReceive(async);

        if (iRx == 0)
        {
            Console.WriteLine("종료");
            //connected = false;
            return;
        }

        Console.WriteLine($"{i++} DEPTH: " + theSockId[0] * 256 + theSockId[1] + ", Width: " + theSockId[2] * 256 + theSockId[3]);

        client.Client.BeginReceive(buffer, 0, 5,
                        SocketFlags.None, new AsyncCallback(OnDataReceived), buffer);
    }
    catch (Exception e)
    {
        Console.WriteLine(e.Message);
    }

}

